-- name: [CS] Glenn Quagmire
-- description: Giggity

local TEXT_MOD_NAME = "I'm Glenn Quagmire"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_QUAGMIRE = smlua_model_util_get_id("quagmire_geo") -- Located in "actors"

local TEX_QUAGMIRE = get_texture_info("quagmire-icon") -- Located in "textures"

-- All Located in "sound"
local VOICETABLE_QUAGMIRE = {
    [CHAR_SOUND_ATTACKED] = 'quagmire_giggity_sad.ogg',
    [CHAR_SOUND_DOH] = 'quagmire_ahcomeon.ogg',
    [CHAR_SOUND_DROWNING] = 'quagmire_scream.ogg',
    [CHAR_SOUND_DYING] = 'quagmire_scream.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'quagmire_giggity.ogg',
    [CHAR_SOUND_HAHA] = 'quagmire_giggity1.ogg',
    [CHAR_SOUND_HAHA_2] = 'quagmire_giggity2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'quagmire_ohmygod_excited.ogg',
    [CHAR_SOUND_HOOHOO] = 'quagmire_alright.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'quagmire_idontknowificandothis.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'quagmire_watchthis.ogg',
    [CHAR_SOUND_ON_FIRE] = 'quagmire_scream.ogg',
    [CHAR_SOUND_OOOF] = 'quagmire_thatsnothelping.ogg',
    [CHAR_SOUND_OOOF2] = 'quagmire_ahcomeon.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'quagmire_giggity3.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'quagmire_giggity2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'quagmire_giggity1.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'quagmire_thatoughttadoit.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'quagmire_giggity3.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'quagmire_scream.ogg',
    [CHAR_SOUND_WAH2] = 'quagmire_giggity.ogg',
    [CHAR_SOUND_WHOA] = 'quagmire_giggity.ogg',
    [CHAR_SOUND_YAHOO] = 'quagmire_giggity3.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'quagmire_giggity3.ogg', 'quagmire_giggity1.ogg', 'quagmire_giggity2.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'quagmire_giggity1.ogg', 'quagmire_giggity2.ogg', 'quagmire_giggity3.ogg'},
}

local CSloaded = false
local function on_character_select_load()
    CT_CHAR = _G.charSelect.character_add("Glenn Quagmire", {"I'm Glenn Quagmire", "GIGGITY GIGGITY GOO"}, "Hell Inspector", {r = 238, g = 51, b = 34}, E_MODEL_QUAGMIRE, CT_MARIO, TEX_QUAGMIRE)
    _G.charSelect.character_add_voice(E_MODEL_QUAGMIRE, VOICETABLE_QUAGMIRE)
    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_QUAGMIRE then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_QUAGMIRE then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)